VERSION 5.00
Begin VB.Form frmVis5 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00000000&
   Caption         =   "rumint: Scatter Plot"
   ClientHeight    =   5325
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   8100
   Icon            =   "frmVis5.frx":0000
   LinkTopic       =   "Form1"
   MinButton       =   0   'False
   ScaleHeight     =   5325
   ScaleWidth      =   8100
   StartUpPosition =   2  'CenterScreen
   Begin VB.ComboBox comboAxis 
      Height          =   315
      Index           =   1
      Left            =   0
      TabIndex        =   2
      Text            =   "Combo1"
      Top             =   0
      Visible         =   0   'False
      Width           =   1935
   End
   Begin VB.ComboBox comboAxis 
      Height          =   315
      Index           =   2
      Left            =   3240
      TabIndex        =   1
      Text            =   "Combo1"
      Top             =   4920
      Visible         =   0   'False
      Width           =   1935
   End
   Begin VB.PictureBox picGraph 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H00000000&
      BorderStyle     =   0  'None
      FillStyle       =   0  'Solid
      ForeColor       =   &H80000008&
      Height          =   4575
      Left            =   360
      ScaleHeight     =   305
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   273
      TabIndex        =   0
      Top             =   360
      Width           =   4095
   End
   Begin VB.Shape shpHorzAxis 
      BackColor       =   &H00404040&
      BackStyle       =   1  'Opaque
      BorderStyle     =   0  'Transparent
      Height          =   375
      Left            =   0
      Top             =   4920
      Width           =   8175
   End
   Begin VB.Shape shpVertAxis 
      BackColor       =   &H00404040&
      BackStyle       =   1  'Opaque
      BorderStyle     =   0  'Transparent
      Height          =   5295
      Left            =   0
      Top             =   0
      Width           =   375
   End
End
Attribute VB_Name = "frmVis5"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'RUMINT, A PVR for network traffic
'Copyright (C) 2005 Greg Conti

'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2
'of the License, or (at your option) any later version.

'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Option Explicit

Private Const NUMVARIABLES = 2

Dim axis(1 To 19) As Long 'used for placing things on the form
Dim scaledAxis(1 To 19) As Long 'used for placing things in the picgraph
Dim numColumns As Long 'number of vertical axes in graph
Dim plotColor As ColorConstants
  
'add mouseover information

'********************** Graphics ****************************
Public Sub plotThumbnail(ByVal packetNumber As Long)
  Dim counter As Long
  Dim scaledValue(1 To 2) As Long
  Dim unscaledValue(1 To 2) As Long
  Dim label(1 To 2) As String
  Dim octet1 As Long
  Dim octet2 As Long
  Dim AxisLength(1 To 2) As Long
  
  'determine dimensions of thumbnail picgraph
  AxisLength(1) = frmMain.picVis(5).ScaleHeight
  AxisLength(2) = frmMain.picVis(5).ScaleWidth
      
  'vertical axis --> source IP
  counter = 1
  octet1 = modLibrary.getSourceIP(packetNumber, 1)
  octet2 = modLibrary.getSourceIP(packetNumber, 2)
  unscaledValue(counter) = (octet1 * 256) + octet2
  scaledValue(counter) = scaleRange(counter, unscaledValue(counter), 65536, AxisLength(counter))
    
  'horizontal axis --> packet length
  counter = 2
  unscaledValue(counter) = modLibrary.getPacketLen(packetNumber)
  scaledValue(counter) = scaleRange(counter, unscaledValue(counter), 1518, AxisLength(counter))
    
  'plot to thumbnail
  frmMain.picVis(5).PSet (scaledValue(2), scaledValue(1)), vbGreen
End Sub

Public Sub Plot(ByVal packetNumber As Long)
  Dim counter As Long
  Dim scaledValue(1 To 19) As Long
  Dim unscaledValue(1 To 19) As Long
  Dim label(1 To 19) As String
  Dim octet1 As Long
  Dim octet2 As Long
  Dim AxisLength(1 To NUMVARIABLES) As Long
  
  AxisLength(1) = picGraph.ScaleHeight
  AxisLength(2) = picGraph.ScaleWidth
  
  plotColor = modEncodings.SetPlotColor(modLibrary.getPacketIPtransportProtocol(packetNumber))
  
  For counter = 1 To NUMVARIABLES
    
    If comboAxis(counter).ListIndex = 0 Then
      unscaledValue(counter) = modLibrary.getPacketLen(packetNumber) 'packetLength
      label(counter) = unscaledValue(counter)
      scaledValue(counter) = scaleRange(counter, unscaledValue(counter), 1518, AxisLength(counter))
    End If
    
    If comboAxis(counter).ListIndex = 1 Then 'Ethertype
      unscaledValue(counter) = modLibrary.getEtherType(packetNumber)
      'Debug.Print (unscaledValue(counter))
      label(counter) = modLibrary.getEtherTypeString(packetNumber)
      scaledValue(counter) = scaleRange(counter, unscaledValue(counter), 65536, AxisLength(counter))
    End If
    
    If comboAxis(counter).ListIndex = 2 Then 'IP version
      unscaledValue(counter) = modLibrary.getIPVersion(packetNumber)
      label(counter) = unscaledValue(counter)
      scaledValue(counter) = scaleRange(counter, unscaledValue(counter), 16, AxisLength(counter))
    End If
    
    If comboAxis(counter).ListIndex = 3 Then 'IP header len
      unscaledValue(counter) = modLibrary.getIPHeaderLen(packetNumber)
      label(counter) = unscaledValue(counter)
      scaledValue(counter) = scaleRange(counter, unscaledValue(counter), 16, AxisLength(counter))
    End If
    
    If comboAxis(counter).ListIndex = 4 Then 'IP differentiated services
      unscaledValue(counter) = modLibrary.getDifferentiatedServices(packetNumber)
      'Debug.Print (unscaledValue(counter))
      label(counter) = unscaledValue(counter)
      scaledValue(counter) = scaleRange(counter, unscaledValue(counter), 256, AxisLength(counter))
    End If
    
    If comboAxis(counter).ListIndex = 5 Then 'IP total length
      unscaledValue(counter) = modLibrary.getIPtotalLength(packetNumber)
      'Debug.Print (unscaledValue(counter))
      label(counter) = unscaledValue(counter)
      scaledValue(counter) = scaleRange(counter, unscaledValue(counter), 65536, AxisLength(counter))
    End If
    
    If comboAxis(counter).ListIndex = 6 Then 'IP identification
      unscaledValue(counter) = modLibrary.getIPidentification(packetNumber)
      'Debug.Print (unscaledValue(counter))
      label(counter) = unscaledValue(counter)
      scaledValue(counter) = scaleRange(counter, unscaledValue(counter), 65536, AxisLength(counter))
    End If
    
    If comboAxis(counter).ListIndex = 7 Then 'IP flags
      If modLibrary.getIPflagsR(packetNumber) Then label(counter) = label(counter) & "reserved"
      If modLibrary.getIPflagsDF(packetNumber) Then label(counter) = label(counter) & "DF"
      If modLibrary.getIPflagsMF(packetNumber) Then label(counter) = label(counter) & "MF"
      unscaledValue(counter) = unscaledValue(counter)
      scaledValue(counter) = scaleRange(counter, unscaledValue(counter), 8, AxisLength(counter))
    End If
    
    If comboAxis(counter).ListIndex = 8 Then 'IP fragment offset
      unscaledValue(counter) = modLibrary.getIPfragmentoffset(packetNumber)
      'Debug.Print (unscaledValue(counter))
      label(counter) = unscaledValue(counter)
      scaledValue(counter) = scaleRange(counter, unscaledValue(counter), 8192, AxisLength(counter))
    End If
    
    If comboAxis(counter).ListIndex = 9 Then
      unscaledValue(counter) = modLibrary.getIPTTL(packetNumber) 'IP TTL
      label(counter) = unscaledValue(counter)
      scaledValue(counter) = scaleRange(counter, unscaledValue(counter), 256, AxisLength(counter))
    End If
        
    If comboAxis(counter).ListIndex = 10 Then
      unscaledValue(counter) = modLibrary.getPacketIPtransportProtocol(packetNumber) 'IP transport protocol field
      label(counter) = unscaledValue(counter)
      scaledValue(counter) = scaleRange(counter, unscaledValue(counter), 256, AxisLength(counter))
    End If
    
    If comboAxis(counter).ListIndex = 11 Then 'IP header checksum
      unscaledValue(counter) = modLibrary.getIPheaderchecksum(packetNumber)
      Debug.Print (unscaledValue(counter))
      label(counter) = unscaledValue(counter)
      scaledValue(counter) = scaleRange(counter, unscaledValue(counter), 65536, AxisLength(counter))
    End If
    
    If comboAxis(counter).ListIndex = 12 Then 'source IP
      label(counter) = modLibrary.getSourceIPstring(packetNumber)
      octet1 = modLibrary.getSourceIP(packetNumber, 1) 'unscaledValue(counter)
      octet2 = modLibrary.getSourceIP(packetNumber, 2)
      unscaledValue(counter) = (octet1 * 256) + octet2 'beware weird overflow error
      'unscaledValue(counter) = (((octet1 / 2) * 2) * 256) + octet2
      scaledValue(counter) = scaleRange(counter, unscaledValue(counter), 65536, AxisLength(counter))
    End If
    
    If comboAxis(counter).ListIndex = 13 Then 'dest IP
      label(counter) = modLibrary.getDestIPstring(packetNumber)
      octet1 = modLibrary.getDestIP(packetNumber, 1)
      octet2 = modLibrary.getDestIP(packetNumber, 2)
      unscaledValue(counter) = (octet1 * 256) + octet2
      scaledValue(counter) = scaleRange(counter, unscaledValue(counter), 65536, AxisLength(counter))
    End If
    
    If comboAxis(counter).ListIndex = 14 Then 'TCP Source Port
      unscaledValue(counter) = modLibrary.getTCPsourcePort(packetNumber)
      'Debug.Print (unscaledValue(counter))
      label(counter) = unscaledValue(counter)
      scaledValue(counter) = scaleRange(counter, unscaledValue(counter), 65536, AxisLength(counter))
    End If
    
    If comboAxis(counter).ListIndex = 15 Then 'TCP Destination Port
      unscaledValue(counter) = modLibrary.getTCPdestPort(packetNumber)
      'Debug.Print (unscaledValue(counter))
      label(counter) = unscaledValue(counter)
      scaledValue(counter) = scaleRange(counter, unscaledValue(counter), 65536, AxisLength(counter))
    End If
    
    If comboAxis(counter).ListIndex = 16 Then 'TCP Sequence Number
      label(counter) = modLibrary.getTCPsequencenumberString(packetNumber)
      octet1 = modLibrary.getTCPsequencenumber(packetNumber, 1)
      octet2 = modLibrary.getTCPsequencenumber(packetNumber, 2)
      unscaledValue(counter) = (octet1 * 256) + octet2
      scaledValue(counter) = scaleRange(counter, unscaledValue(counter), 65536, picGraph.ScaleHeight)
    End If
    
    If comboAxis(counter).ListIndex = 17 Then 'UDP Source Port
      unscaledValue(counter) = modLibrary.getUDPsourcePort(packetNumber)
      'Debug.Print (unscaledValue(counter))
      label(counter) = unscaledValue(counter)
      scaledValue(counter) = scaleRange(counter, unscaledValue(counter), 65536, AxisLength(counter))
    End If
    
    If comboAxis(counter).ListIndex = 18 Then 'UDP Destination Port
      unscaledValue(counter) = modLibrary.getUDPdestPort(packetNumber)
      'Debug.Print (unscaledValue(counter))
      label(counter) = unscaledValue(counter)
      scaledValue(counter) = scaleRange(counter, unscaledValue(counter), 65536, AxisLength(counter))
    End If
    
  Next
  
  'For counter = 1 To numColumns - 1
  'Debug.Print scaledValue(1) & "  " & scaledValue(2) & "  " & label(1) & " " & label(2)
  'Next counter
  
  If Hex(modLibrary.getEtherType(packetNumber)) = 800 Then
    Call PlotPoint(scaledValue(1), scaledValue(2), label(1), label(2))
  Else
    If (comboAxis(1).ListIndex = 0 Or comboAxis(1).ListIndex = 1) And _
       (comboAxis(2).ListIndex = 0 Or comboAxis(2).ListIndex = 1) Then
      
       Call PlotPoint(scaledValue(1), scaledValue(2), label(1), label(2))
    Else
      If (comboAxis(1).ListIndex = 0 Or comboAxis(1).ListIndex = 1) Then
        Call PlotPoint(scaledValue(1), 0, label(1), "")
      Else
        If (comboAxis(2).ListIndex = 0 Or comboAxis(2).ListIndex = 1) Then
          Call PlotPoint(0, scaledValue(2), "", label(2))
        End If
      End If
    End If
  End If
End Sub

Public Function scaleRange(ByVal counter, ByVal actualValue As Variant, ByVal maxRange As Variant, ByVal displayValue As Variant) As Variant
  If counter = 1 Then 'vertical
    If displayValue <= 0 Then
      scaleRange = 0 'returns a zero to avoid division by zero
    Else
      scaleRange = displayValue - ((actualValue / maxRange) * displayValue) 'start from top
    End If
  Else
    If counter = 2 Then 'horizontal
      If displayValue <= 0 Then
        scaleRange = 0 'returns a zero to avoid division by zero
      Else
        scaleRange = (actualValue / maxRange) * displayValue
      End If
    End If
  End If
End Function

Private Sub PlotPoint(ByVal scaledValue1 As Long, ByVal scaledValue2 As Long, _
                     ByVal unscaledValue1 As String, ByVal unscaledValue2 As String)
  
  'Debug.Print scaledValue2 & "(" & picGraph.ScaleWidth & ") " & scaledValue1 & "(" & picGraph.ScaleHeight & ") "
  picGraph.FillColor = plotColor
  'picGraph.Circle (scaledValue2, scaledValue1), 2, plotColor
  picGraph.PSet (scaledValue2, scaledValue1), plotColor
  
  picGraph.CurrentX = scaledValue2 + 1
  picGraph.CurrentY = scaledValue1 + 1
  picGraph.ForeColor = RGB(64, 64, 64)
  picGraph.Print unscaledValue2 & "," & unscaledValue1
    
  picGraph.CurrentX = scaledValue2
  picGraph.CurrentY = scaledValue1
  picGraph.ForeColor = vbWhite
  picGraph.Print unscaledValue2 & "," & unscaledValue1
        
   
End Sub


'************************ Form ******************************
Private Sub Form_Load()
 Dim counter As Long
 For counter = 1 To 2 'create a number of hidden combobox objects for axis control
    'Load comboAxis(counter)
    With comboAxis(counter)
    
      'external information
      .AddItem ("packet length")
      
      'layer 2
      .AddItem ("Ethertype")
      
      'layer 3
         'IP
         .AddItem ("IP Version")
         .AddItem ("IP Header Len")
         .AddItem ("IP Diff Services")
         .AddItem ("IP Total Length")
         .AddItem ("IP Identification")
         .AddItem ("IP Flags")
         .AddItem ("IP Fragment Offset")
         .AddItem ("TTL")
         .AddItem ("IP Transport Protocol")
         .AddItem ("IP Header Checksum")
         .AddItem ("Source IP")
         .AddItem ("Dest IP")
           
      'layer 4
         'TCP
           .AddItem ("TCP Source Port")
           .AddItem ("TCP Dest Port")
           .AddItem ("TCP Sequence Number")
         'UDP
           .AddItem ("UDP Source Port")
           .AddItem ("UDP Dest Port")
      
      '.ListIndex = counter - 1 'make this more intelligent in the future
      .ListIndex = modPreferences.scatterplotComboDefault(counter) 'modPrefences
      
    End With
 Next counter
End Sub

Private Sub Form_Resize()
  Dim meHeight As Long
  Dim counter As Long
    
  'put in code to prevent too small a window size
  If Me.Height < 3000 Then Me.Height = 3000
  If Me.Width < 2000 Then Me.Width = 2000
  
  meHeight = Me.Height 'remember form scale mode should be set for twips
  picGraph.Cls
  picGraph.Left = shpVertAxis.Width - 8
  picGraph.Top = comboAxis(1).Height + 30
  picGraph.Height = Me.Height - 1200
  picGraph.Width = Me.Width
  'picGraph.FillColor = plotColor
  picGraph.FillStyle = vbFSSolid
   
  numColumns = NUMVARIABLES
  axis(1) = 0 'vertical axis
  scaledAxis(1) = 0
  
  axis(2) = 0
  scaledAxis(2) = 0
  
  comboAxis(1).Left = 30
  comboAxis(1).Top = 0
  comboAxis(1).Visible = True
  comboAxis(2).Left = picGraph.Width - comboAxis(2).Width - 150
  comboAxis(2).Top = picGraph.Height + picGraph.Top + 100
  comboAxis(2).Visible = True
  shpVertAxis.Height = Me.Height
  shpHorzAxis.Width = Me.Width
  shpHorzAxis.Top = Me.Height - 750
  
  
End Sub

Private Sub Form_Unload(Cancel As Integer)
  Call modLibrary.UnloadedForm(Me, frmFilters.vis5)
    modPreferences.scatterplotComboDefault(1) = comboAxis(1).ListIndex
    modPreferences.scatterplotComboDefault(2) = comboAxis(2).ListIndex
End Sub

Public Sub ScreenShot(systemTime As String)
  SavePicture picGraph.Image, App.Path & "\" & systemTime & "_scatterplot.bmp"
End Sub

Public Sub clear()
  picGraph.Cls
  frmMain.picVis(5).Cls
End Sub

